function love.load()
	box = {
		x = 10,
		y = 10,
		width = 100,
		height = 100,
		dragging = { active = false, diff_x = 0, diff_y = 0 },
		color = {0, 200, 0},
		visible = true
	}

	target = {
		x = 300,
		y = 300,
		width = 100,
		height = 100,
		color = {200, 0, 200},
		hilight = {0, 250, 250}
	}
end

function love.update(dt)
	if box.dragging.active then
		box.x = love.mouse.getX() - box.dragging.diff_x
		box.y = love.mouse.getY() - box.dragging.diff_y
	end
end

function love.draw()
	draw_target()

	if box.visible then
		draw_box()
	end
end

function love.mousepressed(x, y, button)
	if rectangle_intersection(x, y, 1, 1, box.x, box.y, box.width, box.height) and box.visible then
		box.dragging.active = true
		box.dragging.diff_x = x - box.x
		box.dragging.diff_y = y - box.y
	end
end

function love.mousereleased(x, y, button)
	box.dragging.active = false

	if rectangle_intersection(box.x, box.y, box.width, box.height, target.x, target.y, target.width, target.height) then
		box.visible = false
	end
end

function draw_box()
	love.graphics.setColor(box.color)
	love.graphics.rectangle('fill', box.x, box.y, box.width, box.height)
end

function draw_target()
	if rectangle_intersection(box.x, box.y, box.width, box.height, target.x, target.y, target.width, target.height) and box.visible then
		love.graphics.setColor(target.hilight)
	else
		love.graphics.setColor(target.color)
	end
	love.graphics.rectangle('fill', target.x, target.y, target.width, target.height)
end

function rectangle_intersection(ax1,ay1,aw,ah, bx1,by1,bw,bh)
	local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
	return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end
